<template>
    <v-row justify="center">
        <v-col cols="6">
            <v-card>
                <v-card-title>
                    {{ $t('product_', [$tc('brand', 2)]) }}

                    <v-spacer></v-spacer>

                    <v-btn color="primary" @click="addBrand">
                        <v-icon left>mdi-plus</v-icon>
                        <span>{{ $tc('brand', 2) }}</span>
                    </v-btn>
                </v-card-title>

                <v-card-text>
                    <v-container class="white pa-5">
                        <ValidationObserver ref="brandObserver" v-slot="{ validate, reset }">
                            <v-row v-for="(brand, index) in brands" :key="brand.id">

                                <div class="col flex-grow-0 flex-shrink-1 align-self-center action">
                                    <v-btn
                                        small
                                        icon
                                        color="error"
                                        :disabled="brand.products_count > 0"
                                        @click="remove(brand)"
                                    >
                                        <v-icon>mdi-delete</v-icon>
                                    </v-btn>
                                </div>

                                <v-col class="flex-grow-1 flex-shrink-0">
                                    <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                        <v-text-field
                                            v-model="brand.name"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </v-col>

                                <v-col class="flex-grow-1 flex-shrink-0  mt-3">
                                    <v-switch class="toggle"
                                              v-model="brand.enabled"
                                              :label="$t('enabled')"
                                              :true-value="1"
                                              :false-value="0"
                                              inset
                                              hide-details
                                    >
                                    </v-switch>
                                </v-col>
                            </v-row>
                        </ValidationObserver>
                    </v-container>
                </v-card-text>

                <v-card-actions class="justify-center pa-5">
                    <v-btn
                        class="primary"
                        color="white"
                        large
                        :loading="loading"
                        @click="saveChanges"
                    >
                        <v-icon left>mdi-content-save</v-icon>
                        {{ $t('save') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>

        <v-dialog
            v-if="creating"
            v-model="createDialog"
            persistent
            max-width="400"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('create_', [$tc('brand', 1)]) }}
                </v-card-title>

                <v-card-text>
                    <v-container>
                        <v-row>
                            <v-col>
                                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                    <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                        <v-text-field
                                            v-model="creating.name"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </ValidationObserver>
                            </v-col>

                            <v-col class="flex-grow-1 flex-shrink-0  mt-3">
                                <v-switch class="toggle"
                                          v-model="creating.enabled"
                                          :label="$t('enabled')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card-text>

                <v-card-actions class="justify-center pa-5">
                    <v-btn
                        class="error"
                        color="white"
                        text
                        :loading="loading"
                        @click="cancelCreate"
                    >
                        <v-icon left>mdi-cancel</v-icon>
                        {{ $t('cancel') }}
                    </v-btn>

                    <v-btn
                        class="primary"
                        color="white"
                        text
                        :loading="loading"
                        @click="createBrand"
                    >
                        <v-icon left>mdi-plus</v-icon>
                        {{ $t('create') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="deleteDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$tc('brand', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="pt-2 mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="cancel"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="yes"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import { mapMutations } from "vuex";

    export default {
        name: "ProductBrand",
        components: {ValidationObserver, ValidationProvider},

        data: () => ({
            loading: true,
            deleteDialog: false,
            createDialog: false,
            creating: null,
            deleting: null,
            brands: [],
            snackbar: {
                show: false,
                color: null,
                timeout: 6000,
                message: ''
            },
        }),

        mounted() {
            this.fetchBrands()
                .then(data => {
                    this.loading = false;
                    this.brands = data;
                });
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchBrands() {
                return new Promise((resolve, reject) => {
                    axios.get('api/brands/all')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                });
            },

            remove(brand) {
                this.deleting = brand;
                this.deleteDialog = true;
            },

            addBrand() {
                this.creating = { name: '' };
                this.createDialog = true;
            },

            cancelCreate() {
                this.creating = null;
                this.createDialog = false;
            },

            createBrand() {
                this.loading = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            axios.post('api/brands', this.creating)
                                .then(({ data }) => {
                                    this.brands.push(data);
                                    this.cancelCreate();

                                    this.success(this.$t('brand_action.created'));
                                })
                                .catch(({ response }) => {
                                    this.error(response.data.message);
                                })
                                .finally(() => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    });
            },

            saveChanges() {
                this.loading = true;

                this.$refs.brandObserver.validate()
                    .then(valid => {
                        if(valid) {
                            axios.patch('api/brands', {
                                brands: this.brands
                            })
                                .then(({ data }) => {
                                    this.brands = data;
                                    this.success(this.$t('brand_action.updated'))
                                })
                                .catch(({ response }) => {
                                    this.error(response.data.message);
                                })
                                .finally(() => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    });
            },

            cancel() {
                this.deleting = null;
                this.deleteDialog = false;
            },

            yes() {
                this.loading = true;

                axios.delete(`api/brands/${this.deleting.id}`)
                    .then(({ data }) => {
                        const index = this.brands.findIndex(b => b.id === this.deleting.id);
                        this.brands.splice(index, 1);
                        this.cancel();

                        this.success(this.$t('brand_action.deleted'))
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            }
        }
    }
</script>

<style scoped>
</style>
